#include <FastLED.h>
//
#define DATA_RLower_PIN 12      //This is the helmet's right side matrix
#define DATA_LLower_PIN 11       //This is the helmet's left side matrix
#define NUM_LEDS    20        // The LED frames are 7 LEDs in 8 groups/segments 
#define BRIGHTNESS  32        //Brightness level of leds adjustable and not to burn out the LEDS.
#define LED_TYPE    WS2812B   //Type of addressable LED strip I am using
#define COLOR_ORDER GRB       //Led type as manufactured.
//
// UV Meter Connections
int DO = 2; //Pin for Digital Output - DO
int AO = A0; // Pin for Analog Output - AO
int threshold1 = 100; //Set minimum threshold for LED lit
int threshold2 = 200; //Set minimum threshold for LED lit
int threshold3 = 300; //Set minimum threshold for LED lit
int threshold4 = 400; //Set minimum threshold for LED lit
int threshold5 = 500; //Set minimum threshold for LED lit
int threshold6 = 600; //Set minimum threshold for LED lit
int threshold7 = 700; //Set minimum threshold for LED lit
int threshold8 = 800; //Set minimum threshold for LED lit
int threshold9 = 900; //Set minimum threshold for LED lit
int sensorvalue = 0;
//
CRGB led_array[NUM_LEDS];
#define UPDATES_PER_SECOND 100
//..........................................
long randLED1,randLED2,randLED3,randLED4,randLED5,randLED6,randLED7,randLED8;
//
const uint8_t kMatrixWidth = 1;          // break up LED string into a matrix 7 leds in width x 8 groups(or rows) high.
const uint8_t kMatrixHeight = 20;        // Width x height = total number of leds in your string (here it is 7x8 = 56).
const bool    kMatrixSerpentineLayout = true;   // True if Leds are wired in a serpintine assembled pattern, false if led strip is laid out as a linear orientation.
//
// Calculates position on string based on coordinates.  This sets up the serpentine / zig zag to work.
uint16_t XY( uint8_t x, uint8_t y)
//                               XY(x,y) takes x and y coordinates and returns an LED index number,
//                               for use like this:  leds[ XY(x,y) ] == CRGB::Red;
//                               No error checking is performed on the ranges of x and y.
{
  uint16_t i;
//                               This function will return the right 'led index number' for
//                                a given set of X and Y coordinates on your matrix.
//
  if( kMatrixSerpentineLayout == false) {
    i = (y * kMatrixWidth) + x;
  }
  if( kMatrixSerpentineLayout == true) {
    if( y & 0x01) {
      // Odd rows run backwards
      uint8_t reverseX = (kMatrixWidth - 1) - x;
      i = (y * kMatrixWidth) + reverseX;
    } else {
      // Even rows run forwards
      i = (y * kMatrixWidth) + x;
    }
  }
    return i;
}
CRGBPalette16 currentPalette;  // Calling up the library for pallette to be assigned to "current pallette"
TBlendType    currentBlending;  // Calling up the library for method for blending colors
//
//............... SET UP......................................... 
void setup() {
    delay( 3000 ); // power-up safety delay
    Serial.begin(9600);    // Open Serial port to help trouble shoot when a button is being pressed.

    // Calling up FastLed code to assign the pin to the LED string being used, the size etc....
    
    FastLED.addLeds<LED_TYPE, DATA_RLower_PIN, COLOR_ORDER>(led_array, NUM_LEDS).setCorrection( TypicalLEDStrip );
    FastLED.addLeds<LED_TYPE, DATA_LLower_PIN, COLOR_ORDER>(led_array, NUM_LEDS).setCorrection( TypicalLEDStrip );
    FastLED.setBrightness(  BRIGHTNESS );
    // Set up the ear outputs....
      pinMode(8, OUTPUT);
  digitalWrite(8,LOW);
    pinMode(7, OUTPUT);
  digitalWrite(7,LOW);
    pinMode(6, OUTPUT);
  digitalWrite(6,LOW);
    pinMode(5, OUTPUT);
  digitalWrite(5,LOW);
    pinMode(4, OUTPUT);
  digitalWrite(4,LOW);
    pinMode(15, OUTPUT);
  digitalWrite(15,LOW);
    pinMode(16, OUTPUT);
  digitalWrite(16,LOW);
    pinMode(17, OUTPUT);
  digitalWrite(17,LOW);
    pinMode(18, OUTPUT);
  digitalWrite(18,LOW);
    pinMode(19, OUTPUT);
  digitalWrite(19,LOW);
    currentPalette = RainbowColors_p;  //Calls up the rainbow pallette already canned in the library.
    currentBlending = LINEARBLEND;     //Calls up the blending method.
}
// ___________________SUBROUTINE ANIMATIONS START HERE _________________________
//
//
void clear()                      //  Clears the entire display to OFF of "black."
{
    for (int i = 0; i < NUM_LEDS; i++)
    {
        led_array[i] = CRGB::Black;
    }
    FastLED.show();
}
//
//.....................................
void fadeall() { for(int i = 0; i < NUM_LEDS; i++) { led_array[i].nscale8(250); } }

void EARS()
{
  //    Drive the ears ...........
  for( int i=4; i<=8;i++)
  {digitalWrite(i, HIGH); // turn the Green LED ON 
    digitalWrite(i+11, HIGH); // turn the Green LED ON 
    delay(175);              //Delay for sustaining the green led to look light a heartbeat.
    digitalWrite(i, LOW);    // turn the Green LED OFF
    digitalWrite(i+11, LOW);   // turn the Green LED OFF
  }
}


void SLIDERandEARS()  // 
{
sensorvalue = analogRead(A0); //Read the analog value
Serial.print("Analog: ");
Serial.print(sensorvalue); //Print the analog value
Serial.print(" ");
Serial.print("Digital: ");
Serial.println(digitalRead(DO)); //Print the digital value
//
  //Incremental White scan routine  (Up and Down)
for(int i=0; i<=0;i++)
{
  static uint8_t hue = 0;

// First slide the led in one direction
  EARS();
  for(int i = 1; i < 8; i++)
    {
    led_array[i] = CRGB::White;
    FastLED.show(); 
    delay(100);
    led_array[i] = CRGB::Black;
    FastLED.show();
  }
  EARS();
//
// Now scan down in the other direction. 
delay (125); //Turnaround delay to look right
// 
  for(int i = 6; i >= 0; i--)
    {
    led_array[i] = CRGB::White;
    FastLED.show(); 
    delay(100);
    led_array[i] = CRGB::Black;
    FastLED.show();
  }
}
// Now scan a double set of White LEDs.................
  EARS();
  for(int i = 1; i < 7; i++)
    {
    led_array[i] = CRGB::White;
    led_array[i+1] = CRGB::White;
    FastLED.show(); 
    delay(100);
    led_array[i] = CRGB::Black;
    led_array[i+1] = CRGB::Black;
    FastLED.show();
}
  EARS();
  for(int i = 6; i >= 0; i--)
  {
    led_array[i] = CRGB::White;
    led_array[i-1] = CRGB::White;
    FastLED.show(); 
    delay(100);
    led_array[i] = CRGB::Black;
    led_array[i-1] = CRGB::Black;
    FastLED.show();
  }
  // Now scan a Triple set of White LEDs.................
    EARS();
  for(int i = 1; i < 6; i++)
    {
    led_array[i] = CRGB::White;
    led_array[i+1] = CRGB::White;
    led_array[i+2] = CRGB::White;
    FastLED.show(); 
    delay(100);
    led_array[i] = CRGB::Black;
    led_array[i+1] = CRGB::Black;
    led_array[i+2] = CRGB::Black;
    FastLED.show();
     }
  EARS();
  for(int i = 5; i >= 0; i--)
  {
    led_array[i] = CRGB::White;
    led_array[i-1] = CRGB::White;
    led_array[i-2] = CRGB::White;
    FastLED.show(); 
    delay(100);
    led_array[i] = CRGB::Black;
    led_array[i-1] = CRGB::Black;
    led_array[i-2] = CRGB::Black;
    FastLED.show();
  }
    // Now scan a Quad set of White LEDs.................
    EARS();
  for(int i = 1; i < 5; i++)
    {
    led_array[i] = CRGB::White;
    led_array[i+1] = CRGB::White;
    led_array[i+2] = CRGB::White;
    led_array[i+3] = CRGB::White;
    FastLED.show(); 
    delay(100);
    led_array[i] = CRGB::Black;
    led_array[i+1] = CRGB::Black;
    led_array[i+2] = CRGB::Black;
    led_array[i+3] = CRGB::Black;
    FastLED.show();
     }
  EARS();
  for(int i = 5; i >= 0; i--)
  {
    led_array[i] = CRGB::White;
    led_array[i-1] = CRGB::White;
    led_array[i-2] = CRGB::White;
    led_array[i-3] = CRGB::White;
    FastLED.show(); 
    delay(100);
    led_array[i] = CRGB::Black;
    led_array[i-1] = CRGB::Black;
    led_array[i-2] = CRGB::Black;
    led_array[i-3] = CRGB::Black;
    FastLED.show();
  }
  }
//
//..............................................
void lightRow(int row, CRGB color)
{
    for (int i = 0; i < kMatrixWidth; i++)
    {
        led_array[XY(i, row)] = color;                
    }
    FastLED.show();
}

CRGB rainbow[9] = {CRGB::Red, CRGB::DarkMagenta, CRGB::Blue,
                   CRGB::DarkCyan, CRGB::DarkGreen, CRGB::Chartreuse,
                   CRGB::Yellow, CRGB::OrangeRed, CRGB::Red};

void lightRows(int rows, CRGB color)
{
    for (int i = 0; i < rows; i++)
    {
        lightRow(i, color);
    }
}
// ....................................
void fullColor(CRGB color)
{
    lightRows(kMatrixHeight, color);
}
//
int cycleColor = 0;
//
//..................................................
void WhiteSweep()                     
{
  for (int i=0; i<=8; i++)
  {
    for (int i = 0; i < NUM_LEDS; i++)
    {
        randLED1= random(1,56);
            led_array[randLED1] = CRGB::Red;
        randLED2= random(1,56);
            led_array[randLED2] = CRGB::OrangeRed;
        randLED3= random(1,56);
            led_array[randLED3] = CRGB::Yellow;
        randLED4= random(1,56);
            led_array[randLED4] = CRGB::Chartreuse;
        randLED5= random(1,56);
            led_array[randLED5] = CRGB::DarkGreen;
        randLED6= random(1,56);
            led_array[randLED6] = CRGB::DarkCyan;
        randLED7= random(1,56);
            led_array[randLED7] = CRGB::Blue;
        randLED8= random(1,56);
            led_array[randLED8] = CRGB::DarkMagenta;
        FastLED.show();
        delay(100);
        led_array[randLED1] = CRGB::Black;
        led_array[randLED2] = CRGB::Black;
        led_array[randLED3] = CRGB::Black;
        led_array[randLED4] = CRGB::Black;
        led_array[randLED5] = CRGB::Black;
        led_array[randLED6] = CRGB::Black;
        led_array[randLED7] = CRGB::Black;
        led_array[randLED8] = CRGB::Black;
        
    }
    FastLED.show();
}
}
//
// ------------------------------------ LOOP PROGRAM BELOW ------------------------
void loop()
{
sensorvalue = analogRead(A0); //Read the analog value
Serial.print("Analog: ");
Serial.print(sensorvalue); //Print the analog value
Serial.print(" ");
Serial.print("Digital: ");
Serial.println(digitalRead(DO)); //Print the digital value
SLIDERandEARS();
}
